/* getascii.c
**
**	Generates ascii.h with all codes.
*/

#include <vga.h>
#include <stdio.h>

struct {
   char 	DefineLine [25]; 
   char		Prompt [15];
   unsigned int	Value;
} Keys[] = 
{
	{"#define KEY_ESC\t", "escape", 0},
	{"#define KEY_F1\t", "F1", 0},
	{"#define KEY_F2\t", "F2", 0},
	{"#define KEY_F3\t", "F3", 0},
	{"#define KEY_F4\t", "F4", 0},
	{"#define KEY_F5\t", "F5", 0},
	{"#define KEY_F6\t", "F6", 0},
	{"#define KEY_F7\t", "F7", 0},
	{"#define KEY_F8\t", "F8", 0},
	{"#define KEY_F9\t", "F9", 0},
	{"#define KEY_F10\t", "F10", 0},
	{"#define KEY_F11\t", "F11", 0},
	{"#define KEY_F12\t", "F12", 0},
	{"#define KEY_TAB\t", "tab", 0},
	{"#define KEY_ENTER", "enter", 0},
	{"#define KEY_INS\t", "insert", 0},
	{"#define KEY_DEL\t", "delete", 0},
	{"#define KEY_HOME", "home", 0},
	{"#define KEY_END\t", "end", 0},
	{"#define KEY_PGUP", "page up", 0},
	{"#define KEY_PGDN", "page down", 0},
	{"#define KEY_LEFT", "left arrow", 0},
	{"#define KEY_RIGHT", "right arrow", 0},
	{"#define KEY_UP\t", "up arrow", 0},
	{"#define KEY_DOWN", "down arrow", 0},
	{"#define KEY_BACKSPACE", "backspace", 0},
	{"#define KEY_SPACE", "space", 0},
};

int main()
{
unsigned int i, key;
FILE * fp;

    vga_init();
    vga_setmode (G320x200x256);

    for (i = 0; i < 27; ++ i) {
       printf ("Press the %s key\n", Keys[i].Prompt);
       Keys[i].Value = 0;
       while ((key = vga_getkey()) == 0);
       Keys[i].Value += key;
       while ((key = vga_getkey()) != 0)
	  Keys[i].Value += key;
    }

    vga_setmode (TEXT);

    if ((fp = fopen ("ascii.h", "w")) != NULL) {
       fprintf (fp, "/* ascii.h\n");
       fprintf (fp, "**\tGenerated by getascii. Lists key codes.\n");
       fprintf (fp, "*/\n\n");
       fprintf (fp, "#ifndef __ASCII_H\n");
       fprintf (fp, "#define __ASCII_H\n\n");
       for (i = 0; i < 27; ++ i)
          fprintf (fp, "%s\t\t%d\n", Keys[i].DefineLine, Keys[i].Value);
       fprintf (fp, "\n#endif\n\n");
       fclose (fp);
    }
    else
       printf ("Could not open ascii.h!\n");

    return (0);
}

